{
module Parser (expr) where
import Scanner

}

%name expr
%tokentype { Token }
%error { parseError }
  
%token 
       Let { LetToken }
       In { InToken }
       Plus { PlusToken }
       Assign { AssignToken}
       Var  { VarToken $$  }
       Int { IntToken $$}

%%

expr             : Let Var Assign expr In expr { Let $2 $4 $6  }
                 | expr Plus expr { Plus $1 $3 }
		 | Var { Var $1 }
		 | Int { Const $1 }



{

data MiniFunkExpr = Let String MiniFunkExpr MiniFunkExpr
     | Plus MiniFunkExpr MiniFunkExpr
     | Const Int
     | Var String
     deriving (Eq, Show)

parseError :: [Token] -> a
parseError _ = error "Parse error"

parser :: String -> MiniFunkExpr
parser = expr . alexScanTokens

main = do
  s <- readFile "fst.mfe"
  --s <- getContents
  --print ((expr . alexScanTokens) s)
  print (parser s)


}
